<template>
  <v-app id="inspire">
    <v-main>
      <v-container class="fill-height" fluid>
        <v-row align="center" justify="center">
          <v-col cols="12" sm="8" md="8">
            <v-card class="elevation-12">
              <v-window v-model="step">
                <v-window-item :value="1">
                  <v-row>
                    <v-col cols="12" md="8">
                      <v-card-text class="mt-12">
                        <h1
                          class="text-center display-2 teal--text text--accent-3"
                        >Iniciar sesión</h1>
                        
                        <h4 class="text-center mt-4">Ingrese sus datos de usuario para iniciar sesión</h4>
                        <v-form> <!--  -->
                          <v-text-field
                            label="Name"
                            name="Nombre"
                            prepend-icon="person"
                            type="text"
                            color="teal accent-3"
                            required
                            v-model="username"
                          />

                          <v-text-field
                            id="password"
                            label="Password"
                            name="password"
                            prepend-icon="lock"
                            type="password"
                            color="teal accent-3"
                            v-model="password"
                          />
                        </v-form>
                        
                          <v-alert 
                          dense
                          outlined
                          type="error"
                          v-if="error"
                        >
                          {{msg_error}} <strong>!</strong> </v-alert>
                      </v-card-text>
                      <div class="text-center mt-3">
                        <v-btn rounded color="teal accent-3" dark @click="login">Iniciar sesión</v-btn>
                      </div>
                    </v-col>
                    <v-col cols="12" md="4" class="teal accent-3">
                      <v-card-text class="white--text mt-12">
                        <h1 class="text-center display-1">Hola, colaborador!</h1>
                        <h5
                          class="text-center"
                        >Ingrese sus datos personales y comience trabajar con nosotros</h5>
                      </v-card-text>
                      <div class="text-center">
                        <v-btn rounded outlined dark @click="step++">Registrarse</v-btn>
                      </div>
                    </v-col>
                  </v-row>
                </v-window-item>
                <v-window-item :value="2">
                  <v-row class="fill-height">
                    <v-col cols="12" md="4" class="teal accent-3">
                      <v-card-text class="white--text mt-12">
                        <h1 class="text-center display-1">Bienvenido de nuevo!</h1>
                        <h5
                          class="text-center"
                        >Para mantenerse conectado con nosotros, inicie sesión</h5>
                      </v-card-text>
                      <div class="text-center">
                        <v-btn rounded outlined dark @click="step--">Iniciar sesión</v-btn>
                      </div>
                    </v-col>

                    <v-col cols="12" md="8">
                      <v-card-text class="mt-12">
                        <h1 class="text-center display-2 teal--text text--accent-3">Registrarse</h1>
                        
                        <h4 class="text-center mt-4">Ingrese los datos proporcionados por Molinos San Vicente</h4>
                        <v-form>
                          <v-text-field
                            label="Name"
                            name="Nombre"
                            prepend-icon="person"
                            type="text"
                            color="teal accent-3"
                            v-model="w_username"
                          />
                          <v-text-field
                            label="Email"
                            name="Email"
                            prepend-icon="email"
                            type="text"
                            color="teal accent-3"
                            v-model="w_email"
                          />

                          <v-text-field
                            id="password"
                            label="Password"
                            name="contraseña"
                            prepend-icon="lock"
                            type="password"
                            color="teal accent-3"
                            v-model="w_password"
                          />
                        </v-form>
                      </v-card-text>
                      <div class="text-center mt-n5">
                        <v-btn rounded color="teal accent-3" dark @click="register()">Registrarse</v-btn>
                      </div>
                    </v-col>
                  </v-row>
                </v-window-item>
              </v-window>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>

import axios from 'axios';

export default {
  name: 'Home',
  components: {

  },


  data: () => ({
    step: 1,
    username:"",
    password:"",
    email:"",
    error : false,
    msg_error : "",
    errores : [],

    w_username:"",
    w_password: "",
    w_email:""

  }),
  methods:{
    // Begin login
    login(){

      this.errores = [];
      console.log(this.username);
      console.log(this.password);
      let json = {
        "username" : this.username,
        "password": this.password,

      };
      axios.post('http://64.225.59.243:8006/api/login/', json)
      .then(data =>{
        if(data.data.token != null){
        console.log(data)
        localStorage.token = data.data.token;
        this.$router.push('/dashboard');

        }else{
          this.error = true;
          this.msg_error= "Revise los datos ingresado, no puede iniciar sesión" 
        }
        

      })
      .catch(err => {
        this.error = true;
          this.msg_error= "Revise los datos ingresado, no puede iniciar sesión"
        console.log(" status: ", err.response.status);
        console.log(" data: ", err.response.data);
        if(err.response.status==400){
          console.log(err.response.data);
          if(err.response.data.non_field_errors!=null){
            this.errores.push(err.response.data.non_field_errors);
          }
          else if(err.response.data.username!=null){
            this.errores.push(err.response.data.username);
          }else if(err.response.data.password!=null){
            this.errores.push(err.response.data.password);
          }
        }
      })

      
    }, // End login

    register(){
      this.errores = [];
      console.log(this.w_username);
      console.log(this.w_password);
      let json = {
        "username": this.w_username,
        "email": this.w_email,
        "password": this.w_password,

      };
      axios.post('http://64.225.59.243:8006/api/register/', json)
      .then(data =>{
        if(data.data.token != null){
        localStorage.token = data.data.token;
        localStorage.setItem("TOKEN", data.data.token);
        this.$router.push('/dashboard');

        }else{
          this.error = true;
          this.msg_error= "Revise los datos ingresados, para poder registrarse " 
        }
        

      })
      .catch(err => {
        console.log(" status: ", err.response.status);
        console.log(" data: ", err.response.data);
        if(err.response.status==400){
          console.log(err.response.data);
          if(err.response.data.non_field_errors!=null){
            this.errores.push(err.response.data.non_field_errors);
          }
          else if(err.response.data.username!=null){
            this.errores.push(err.response.data.username);
          }else if(err.response.data.password!=null){
            this.errores.push(err.response.data.password);
          }
        }
      })

    } // End register
  },
  props: {
    source: String
  }
};
</script>